#ifndef __KKRG_CHILDREN_H__
#define __KKRG_CHILDREN_H__

#ifdef CONFIG_KRG_EPM

#include <linux/types.h>

struct children_kddm_object;
struct task_struct;

extern
struct children_kddm_object * (*kh_alloc_children)(struct task_struct *task);
extern void (*kh_share_children)(struct task_struct *task);
extern void (*kh_exit_children)(struct task_struct *task);
extern void (*kh_children_get)(struct children_kddm_object *obj);
extern void (*kh_children_put)(struct children_kddm_object *obj);
extern int (*kh_children_alive)(struct children_kddm_object *obj);
extern int (*kh_new_child)(struct children_kddm_object *obj,
			   pid_t parent_pid,
			   pid_t child_pid, pid_t child_tgid,
			   pid_t pgid, pid_t sid,
			   int exit_signal);
extern void (*kh_set_child_pgid)(struct children_kddm_object *obj,
				 pid_t pid, pid_t pgid);
extern int (*kh_set_child_ptraced)(struct children_kddm_object *obj,
				   pid_t pid, int ptraced);
extern void (*kh_set_child_exit_signal)(struct children_kddm_object *obj,
					pid_t pid, int exit_signal);
extern void (*kh_set_child_exit_state)(struct children_kddm_object *obj,
				       pid_t pid, long exit_signal);
extern void (*kh_set_child_location)(struct children_kddm_object *obj,
				     pid_t pid, kerrighed_node_t node);
extern void (*kh_remove_child)(struct children_kddm_object *obj,
			       pid_t child_pid);
extern void (*kh_reparent_child)(struct children_kddm_object *obj,
				 pid_t child_pid,
				 pid_t reaper_pid, int same_group);
extern void (*kh_forget_original_remote_parent)(struct task_struct *parent,
						struct task_struct *reaper);
extern void (*kh_reparent_to_local_child_reaper)(struct task_struct *task);
extern pid_t (*kh_get_real_parent_tgid)(struct task_struct *task);
extern int (*kh_get_parent)(struct children_kddm_object *obj, pid_t pid,
			    pid_t *parent_pid, pid_t *real_parent_pid);
extern struct children_kddm_object * (*kh_children_writelock)(pid_t tgid);
extern
struct children_kddm_object * (*kh_children_writelock_nested)(pid_t tgid);
extern struct children_kddm_object * (*kh_children_readlock)(pid_t tgid);
extern struct children_kddm_object * (*kh_parent_children_writelock)(
	struct task_struct *task,
	pid_t *parent_tgid);
extern struct children_kddm_object * (*kh_parent_children_readlock)(
	struct task_struct *task,
	pid_t *parent_tgid);
extern void (*kh_children_unlock)(pid_t tgid);
extern void (*kh_update_self_exec_id)(struct task_struct *task);
extern u32 (*kh_get_real_parent_self_exec_id)(struct children_kddm_object *obj);

extern void (*kh_fork_add_parent)(struct task_struct *task, pid_t parent_pid);
extern void (*kh_de_thread_reparent_to_baby_sitter)(struct task_struct *task);
extern void (*kh_de_thread_reparent_to_krg_parent)(struct task_struct *task);
extern void (*kh_update_parents)(struct task_struct *task,
				 pid_t parent_pid, pid_t real_parent_pid);

#endif /* CONFIG_KRG_EPM */

#endif /* __KKRG_CHILDREN_H__ */
