/** Kerrighed Kernel Hooks **/

#ifndef __FAF_H__
#define __FAF_H__

#include <linux/types.h>

struct file;
struct kstat;

extern off_t (*kh_faf_lseek)(struct file *file, off_t offset,
			     unsigned int origin) ;
extern long (*kh_faf_llseek)(struct file *file, unsigned long offset_high,
			     unsigned long offset_low, loff_t * result,
			     unsigned int origin) ;
extern ssize_t (*kh_faf_read)(struct file *file, char * buf, size_t count) ;
extern ssize_t (*kh_faf_write)(struct file *file, const char * buf,
			       size_t count) ;
extern long (*kh_faf_fcntl)(struct file *file, unsigned int cmd,
			    unsigned long arg) ;
extern long (*kh_faf_fcntl64)(struct file *file, unsigned int cmd,
			      unsigned long arg) ;
extern long (*kh_faf_ioctl)(struct file *file, unsigned int cmd,
			    unsigned long arg) ;
extern long (*kh_faf_fstat)(struct file *file, struct kstat *stat) ;
extern long (*kh_faf_fsync)(struct file *file) ;
extern long (*kh_faf_flock)(struct file *file, unsigned int cmd) ;
extern char *(*kh_faf_d_path)(struct file *file, char *buffer, int size);
extern void (*kh_faf_srv_close)(struct file *file);


struct sockaddr;
struct msghdr;

extern long (*kh_faf_bind)(struct file * file, struct sockaddr __user *umyaddr,
			   int addrlen);
extern long (*kh_faf_connect)(struct file * file,
			      struct sockaddr __user *uservaddr, int addrlen);
extern long (*kh_faf_listen)(struct file * file, int backlog);
extern long (*kh_faf_accept)(struct file * file,
			     struct sockaddr __user *upeer_sockaddr,
			     int __user *upeer_addrlen);
extern long (*kh_faf_getsockname)(struct file * file,
				  struct sockaddr __user *usockaddr,
				  int __user *usockaddr_len);
extern long (*kh_faf_getpeername)(struct file * file,
				  struct sockaddr __user *usockaddr,
				  int __user *usockaddr_len);
extern long (*kh_faf_send)(struct file * file, void __user * buff, size_t len,
			   unsigned flags);
extern long (*kh_faf_sendto)(struct file * file, void __user * buff,
			     size_t len, unsigned flags,
			     struct sockaddr __user *addr, int addr_len);
extern long (*kh_faf_recv)(struct file * file, void __user * ubuf, size_t size,
			   unsigned flags);
extern long (*kh_faf_recvfrom)(struct file * file, void __user * ubuf,
			       size_t size, unsigned flags,
			       struct sockaddr __user *addr,
			       int __user *addr_len);
extern long (*kh_faf_shutdown)(struct file * file, int how);
extern long (*kh_faf_setsockopt)(struct file * file, int level, int optname,
				 char __user *optval, int optlen);
extern long (*kh_faf_getsockopt)(struct file * file, int level, int optname,
				 char __user *optval, int __user *optlen);
extern long (*kh_faf_sendmsg)(struct file * file, struct msghdr __user *msg,
			      unsigned flags);
extern long (*kh_faf_recvmsg)(struct file * file, struct msghdr __user *msg,
			      unsigned int flags);
extern int (*kh_faf_poll_wait)(struct file *file, int wait);
extern void (*kh_faf_poll_dequeue)(struct file *file);

/* Remote user access */
extern unsigned long (*kh_copy_user_generic)(void *to, const void *from,
					     unsigned long n, int zerorest);
extern long (*kh___strncpy_from_user)(char *dst, const char __user *src,
				      unsigned long count);
extern unsigned long (*kh___strnlen_user)(const char __user *str,
					  unsigned long n);
extern unsigned long (*kh___clear_user)(void __user *mem, unsigned long len);

#endif // __FAF_H__
